Index: serefpolicy-contrib-20140730/zebra.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/zebra.fc
+++ serefpolicy-contrib-20140730/zebra.fc
@@ -1,21 +1,34 @@
-/etc/quagga(/.*)?	gen_context(system_u:object_r:zebra_conf_t,s0)
-/etc/zebra(/.*)?	gen_context(system_u:object_r:zebra_conf_t,s0)
-
 /etc/rc\.d/init\.d/bgpd	--	gen_context(system_u:object_r:zebra_initrc_exec_t,s0)
-/etc/rc\.d/init\.d/ospf6d	--	gen_context(system_u:object_r:zebra_initrc_exec_t,s0)
-/etc/rc\.d/init\.d/ospfd	--	gen_context(system_u:object_r:zebra_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/ospf6d --	gen_context(system_u:object_r:zebra_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/ospfd --	gen_context(system_u:object_r:zebra_initrc_exec_t,s0)
 /etc/rc\.d/init\.d/ripd	--	gen_context(system_u:object_r:zebra_initrc_exec_t,s0)
-/etc/rc\.d/init\.d/ripngd	--	gen_context(system_u:object_r:zebra_initrc_exec_t,s0)
-/etc/rc\.d/init\.d/zebra	--	gen_context(system_u:object_r:zebra_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/ripngd --	gen_context(system_u:object_r:zebra_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/zebra --	gen_context(system_u:object_r:zebra_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/babeld -- gen_context(system_u:object_r:zebra_initrc_exec_t,s0)
+/etc/rc\.d/init\.d/isisd -- gen_context(system_u:object_r:zebra_initrc_exec_t,s0)
+
+/usr/lib/systemd/system/babeld.*    --  gen_context(system_u:object_r:zebra_unit_file_t,s0)
+/usr/lib/systemd/system/bgpd.*      --  gen_context(system_u:object_r:zebra_unit_file_t,s0)
+/usr/lib/systemd/system/isisd.*     --  gen_context(system_u:object_r:zebra_unit_file_t,s0)
+/usr/lib/systemd/system/ospf6d.*    --  gen_context(system_u:object_r:zebra_unit_file_t,s0)
+/usr/lib/systemd/system/ospfd.*     --  gen_context(system_u:object_r:zebra_unit_file_t,s0)
+/usr/lib/systemd/system/ripd.*      --  gen_context(system_u:object_r:zebra_unit_file_t,s0)
+/usr/lib/systemd/system/ripngd.*    --  gen_context(system_u:object_r:zebra_unit_file_t,s0)
+/usr/lib/systemd/system/zebra.*     --  gen_context(system_u:object_r:zebra_unit_file_t,s0)
 
-/usr/sbin/bgpd	--	gen_context(system_u:object_r:zebra_exec_t,s0)
+/usr/sbin/babeld    --  gen_context(system_u:object_r:zebra_exec_t,s0)
+/usr/sbin/bgpd		--	gen_context(system_u:object_r:zebra_exec_t,s0)
+/usr/sbin/isisd     --  gen_context(system_u:object_r:zebra_exec_t,s0)
 /usr/sbin/ospf.*	--	gen_context(system_u:object_r:zebra_exec_t,s0)
-/usr/sbin/rip.*	--	gen_context(system_u:object_r:zebra_exec_t,s0)
-/usr/sbin/zebra	--	gen_context(system_u:object_r:zebra_exec_t,s0)
+/usr/sbin/rip.*		--	gen_context(system_u:object_r:zebra_exec_t,s0)
+/usr/sbin/zebra		--	gen_context(system_u:object_r:zebra_exec_t,s0)
+
+/etc/quagga(/.*)?		gen_context(system_u:object_r:zebra_conf_t,s0)
+/etc/zebra(/.*)?		gen_context(system_u:object_r:zebra_conf_t,s0)
 
-/var/log/quagga(/.*)?	gen_context(system_u:object_r:zebra_log_t,s0)
-/var/log/zebra(/.*)?	gen_context(system_u:object_r:zebra_log_t,s0)
+/var/log/quagga(/.*)?		gen_context(system_u:object_r:zebra_log_t,s0)
+/var/log/zebra(/.*)?		gen_context(system_u:object_r:zebra_log_t,s0)
 
 /var/run/\.zebra	-s	gen_context(system_u:object_r:zebra_var_run_t,s0)
 /var/run/\.zserv	-s	gen_context(system_u:object_r:zebra_var_run_t,s0)
-/var/run/quagga(/.*)?	gen_context(system_u:object_r:zebra_var_run_t,s0)
+/var/run/quagga(/.*)?		gen_context(system_u:object_r:zebra_var_run_t,s0)
Index: serefpolicy-contrib-20140730/zebra.if
===================================================================
--- serefpolicy-contrib-20140730.orig/zebra.if
+++ serefpolicy-contrib-20140730/zebra.if
@@ -1,8 +1,8 @@
-## <summary>Zebra border gateway protocol network routing service.</summary>
+## <summary>Zebra border gateway protocol network routing service</summary>
 
 ########################################
 ## <summary>
-##	Read zebra configuration content.
+##	Read the configuration files for zebra.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -18,14 +18,13 @@ interface(`zebra_read_config',`
 
 	files_search_etc($1)
 	allow $1 zebra_conf_t:dir list_dir_perms;
-	allow $1 zebra_conf_t:file read_file_perms;
-	allow $1 zebra_conf_t:lnk_file read_lnk_file_perms;
+	read_files_pattern($1, zebra_conf_t, zebra_conf_t)
+	read_lnk_files_pattern($1, zebra_conf_t, zebra_conf_t)
 ')
 
 ########################################
 ## <summary>
-##	Connect to zebra with a unix
-##	domain stream socket.
+##	Connect to zebra over an unix stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -42,10 +41,33 @@ interface(`zebra_stream_connect',`
 	stream_connect_pattern($1, zebra_var_run_t, zebra_var_run_t, zebra_t)
 ')
 
+#######################################
+## <summary>
+##  Execute zebra services in the zebra domain.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed to transition.
+##  </summary>
+## </param>
+#
+interface(`zebra_systemctl',`
+    gen_require(`
+        type zebra_t;
+        type zebra_unit_file_t;
+    ')
+
+        systemd_exec_systemctl($1)
+        allow $1 zebra_unit_file_t:file read_file_perms;
+        allow $1 zebra_unit_file_t:service manage_service_perms;
+
+        ps_process_pattern($1, zebra_t)
+')
+
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an zebra environment.
+##	All of the rules required to administrate
+##	an zebra environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -54,7 +76,7 @@ interface(`zebra_stream_connect',`
 ## </param>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	The role to be allowed to manage the zebra domain.
 ##	</summary>
 ## </param>
 ## <rolecap/>
@@ -62,13 +84,16 @@ interface(`zebra_stream_connect',`
 interface(`zebra_admin',`
 	gen_require(`
 		type zebra_t, zebra_tmp_t, zebra_log_t;
-		type zebra_conf_t, zebra_var_run_t;
-		type zebra_initrc_exec_t;
+		type zebra_conf_t, zebra_var_run_t, zebra_initrc_exec_t;
 	')
 
-	allow $1 zebra_t:process { ptrace signal_perms };
+	allow $1 zebra_t:process signal_perms;
 	ps_process_pattern($1, zebra_t)
 
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 zebra_t:process ptrace;
+	')
+
 	init_labeled_script_domtrans($1, zebra_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 zebra_initrc_exec_t system_r;
@@ -85,4 +110,8 @@ interface(`zebra_admin',`
 
 	files_list_pids($1)
 	admin_pattern($1, zebra_var_run_t)
+
+    zebra_systemctl($1)
+    admin_pattern($1, zebra_unit_file_t)
+    allow $1 zebra_unit_file_t:service all_service_perms;
 ')
Index: serefpolicy-contrib-20140730/zebra.te
===================================================================
--- serefpolicy-contrib-20140730.orig/zebra.te
+++ serefpolicy-contrib-20140730/zebra.te
@@ -6,23 +6,26 @@ policy_module(zebra, 1.13.0)
 #
 
 ## <desc>
-##	<p>
-##	Determine whether zebra daemon can
-##	manage its configuration files.
-##	</p>
+## <p>
+## Allow zebra daemon to write it configuration files
+## </p>
 ## </desc>
-gen_tunable(allow_zebra_write_config, false)
+#
+gen_tunable(zebra_write_config, false)
 
 type zebra_t;
 type zebra_exec_t;
 init_daemon_domain(zebra_t, zebra_exec_t)
 
 type zebra_conf_t;
-files_type(zebra_conf_t)
+files_config_file(zebra_conf_t)
 
 type zebra_initrc_exec_t;
 init_script_file(zebra_initrc_exec_t)
 
+type zebra_unit_file_t;
+systemd_unit_file(zebra_unit_file_t)
+
 type zebra_log_t;
 logging_log_file(zebra_log_t)
 
@@ -40,26 +43,27 @@ files_pid_file(zebra_var_run_t)
 allow zebra_t self:capability { setgid setuid net_admin net_raw };
 dontaudit zebra_t self:capability sys_tty_config;
 allow zebra_t self:process { signal_perms getcap setcap };
-allow zebra_t self:fifo_file rw_fifo_file_perms;
-allow zebra_t self:unix_stream_socket { accept connectto listen };
+allow zebra_t self:file rw_file_perms;
+allow zebra_t self:unix_dgram_socket create_socket_perms;
+allow zebra_t self:unix_stream_socket { connectto create_stream_socket_perms };
 allow zebra_t self:netlink_route_socket rw_netlink_socket_perms;
 allow zebra_t self:tcp_socket { connect connected_stream_socket_perms };
 allow zebra_t self:udp_socket create_socket_perms;
 allow zebra_t self:rawip_socket create_socket_perms;
 
 allow zebra_t zebra_conf_t:dir list_dir_perms;
-allow zebra_t zebra_conf_t:file read_file_perms;
-allow zebra_t zebra_conf_t:lnk_file read_lnk_file_perms;
+read_files_pattern(zebra_t, zebra_conf_t, zebra_conf_t)
+read_lnk_files_pattern(zebra_t, zebra_conf_t, zebra_conf_t)
 
 allow zebra_t zebra_log_t:dir setattr_dir_perms;
-append_files_pattern(zebra_t, zebra_log_t, zebra_log_t)
-create_files_pattern(zebra_t, zebra_log_t, zebra_log_t)
-setattr_files_pattern(zebra_t, zebra_log_t, zebra_log_t)
+manage_files_pattern(zebra_t, zebra_log_t, zebra_log_t)
 manage_sock_files_pattern(zebra_t, zebra_log_t, zebra_log_t)
 logging_log_filetrans(zebra_t, zebra_log_t, { sock_file file dir })
 
-allow zebra_t zebra_tmp_t:sock_file manage_sock_file_perms;
-files_tmp_filetrans(zebra_t, zebra_tmp_t, sock_file)
+# /tmp/.bgpd is such a bad idea!
+manage_sock_files_pattern(zebra_t, zebra_tmp_t, zebra_tmp_t)
+manage_files_pattern(zebra_t, zebra_tmp_t, zebra_tmp_t)
+files_tmp_filetrans(zebra_t, zebra_tmp_t, { file sock_file })
 
 manage_dirs_pattern(zebra_t, zebra_var_run_t, zebra_var_run_t)
 manage_files_pattern(zebra_t, zebra_var_run_t, zebra_var_run_t)
@@ -71,7 +75,6 @@ kernel_read_network_state(zebra_t)
 kernel_read_kernel_sysctls(zebra_t)
 kernel_rw_net_sysctls(zebra_t)
 
-corenet_all_recvfrom_unlabeled(zebra_t)
 corenet_all_recvfrom_netlabel(zebra_t)
 corenet_tcp_sendrecv_generic_if(zebra_t)
 corenet_udp_sendrecv_generic_if(zebra_t)
@@ -79,48 +82,44 @@ corenet_raw_sendrecv_generic_if(zebra_t)
 corenet_tcp_sendrecv_generic_node(zebra_t)
 corenet_udp_sendrecv_generic_node(zebra_t)
 corenet_raw_sendrecv_generic_node(zebra_t)
+corenet_tcp_sendrecv_all_ports(zebra_t)
+corenet_udp_sendrecv_all_ports(zebra_t)
 corenet_tcp_bind_generic_node(zebra_t)
 corenet_udp_bind_generic_node(zebra_t)
-
-corenet_sendrecv_bgp_server_packets(zebra_t)
 corenet_tcp_bind_bgp_port(zebra_t)
-corenet_sendrecv_bgp_client_packets(zebra_t)
+corenet_tcp_bind_zebra_port(zebra_t)
+corenet_udp_bind_router_port(zebra_t)
 corenet_tcp_connect_bgp_port(zebra_t)
-corenet_tcp_sendrecv_bgp_port(zebra_t)
-
 corenet_sendrecv_zebra_server_packets(zebra_t)
-corenet_tcp_bind_zebra_port(zebra_t)
-corenet_tcp_sendrecv_zebra_port(zebra_t)
-
 corenet_sendrecv_router_server_packets(zebra_t)
-corenet_udp_bind_router_port(zebra_t)
-corenet_udp_sendrecv_router_port(zebra_t)
 
 dev_associate_usbfs(zebra_var_run_t)
 dev_list_all_dev_nodes(zebra_t)
+dev_read_rand(zebra_t)
+dev_read_urand(zebra_t)
 dev_read_sysfs(zebra_t)
 dev_rw_zero(zebra_t)
 
-domain_use_interactive_fds(zebra_t)
-
-files_read_etc_files(zebra_t)
-files_read_etc_runtime_files(zebra_t)
-
 fs_getattr_all_fs(zebra_t)
 fs_search_auto_mountpoints(zebra_t)
 
 term_list_ptys(zebra_t)
 
-logging_send_syslog_msg(zebra_t)
+domain_use_interactive_fds(zebra_t)
+
+files_search_etc(zebra_t)
+files_read_etc_runtime_files(zebra_t)
 
-miscfiles_read_localization(zebra_t)
+auth_read_passwd(zebra_t)
+
+logging_send_syslog_msg(zebra_t)
 
 sysnet_read_config(zebra_t)
 
 userdom_dontaudit_use_unpriv_user_fds(zebra_t)
 userdom_dontaudit_search_user_home_dirs(zebra_t)
 
-tunable_policy(`allow_zebra_write_config',`
+tunable_policy(`zebra_write_config',`
 	manage_files_pattern(zebra_t, zebra_conf_t, zebra_conf_t)
 ')
 
@@ -139,3 +138,7 @@ optional_policy(`
 optional_policy(`
 	udev_read_db(zebra_t)
 ')
+
+optional_policy(`
+	unconfined_sigchld(zebra_t)
+')
Index: serefpolicy-contrib-20140730/zoneminder.fc
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/zoneminder.fc
@@ -0,0 +1,13 @@
+/etc/rc\.d/init\.d/zoneminder	--	gen_context(system_u:object_r:zoneminder_initrc_exec_t,s0)
+
+/usr/bin/zmpkg.pl		--	gen_context(system_u:object_r:zoneminder_exec_t,s0)
+
+/usr/lib/systemd/system/zoneminder.* --  gen_context(system_u:object_r:zoneminder_unit_file_t,s0)
+
+/usr/libexec/zoneminder/cgi-bin(/.*)? 	gen_context(system_u:object_r:zoneminder_script_exec_t,s0)
+
+/var/lib/zoneminder(/.*)?		gen_context(system_u:object_r:zoneminder_var_lib_t,s0)
+
+/var/log/zoneminder(/.*)?		gen_context(system_u:object_r:zoneminder_log_t,s0)
+
+/var/spool/zoneminder-upload(/.*)?	gen_context(system_u:object_r:zoneminder_spool_t,s0)
Index: serefpolicy-contrib-20140730/zoneminder.if
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/zoneminder.if
@@ -0,0 +1,374 @@
+## <summary>policy for zoneminder</summary>
+
+########################################
+## <summary>
+##	Transition to zoneminder.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`zoneminder_domtrans',`
+	gen_require(`
+		type zoneminder_t, zoneminder_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, zoneminder_exec_t, zoneminder_t)
+')
+
+########################################
+## <summary>
+##	Allow the specified domain to execute zoneminder
+##	in the caller domain.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`zoneminder_exec',`
+	gen_require(`
+		type zoneminder_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	can_exec($1, zoneminder_exec_t)
+')
+
+
+########################################
+## <summary>
+##	Execute zoneminder server in the zoneminder domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`zoneminder_initrc_domtrans',`
+	gen_require(`
+		type zoneminder_initrc_exec_t;
+	')
+
+	init_labeled_script_domtrans($1, zoneminder_initrc_exec_t)
+')
+
+
+########################################
+## <summary>
+##	Read zoneminder's log files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+## <rolecap/>
+#
+interface(`zoneminder_read_log',`
+	gen_require(`
+		type zoneminder_log_t;
+	')
+
+	logging_search_logs($1)
+	read_files_pattern($1, zoneminder_log_t, zoneminder_log_t)
+')
+
+########################################
+## <summary>
+##	Append to zoneminder log files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`zoneminder_append_log',`
+	gen_require(`
+		type zoneminder_log_t;
+	')
+
+	logging_search_logs($1)
+	append_files_pattern($1, zoneminder_log_t, zoneminder_log_t)
+')
+
+########################################
+## <summary>
+##	Manage zoneminder log files
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`zoneminder_manage_log',`
+	gen_require(`
+		type zoneminder_log_t;
+	')
+
+	logging_search_logs($1)
+	manage_dirs_pattern($1, zoneminder_log_t, zoneminder_log_t)
+	manage_files_pattern($1, zoneminder_log_t, zoneminder_log_t)
+	manage_lnk_files_pattern($1, zoneminder_log_t, zoneminder_log_t)
+')
+
+########################################
+## <summary>
+##	Search zoneminder lib directories.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`zoneminder_search_lib',`
+	gen_require(`
+		type zoneminder_var_lib_t;
+	')
+
+	allow $1 zoneminder_var_lib_t:dir search_dir_perms;
+	files_search_var_lib($1)
+')
+
+########################################
+## <summary>
+##	Read zoneminder lib files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`zoneminder_read_lib_files',`
+	gen_require(`
+		type zoneminder_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	read_files_pattern($1, zoneminder_var_lib_t, zoneminder_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Manage zoneminder lib files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`zoneminder_manage_lib_files',`
+	gen_require(`
+		type zoneminder_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	manage_files_pattern($1, zoneminder_var_lib_t, zoneminder_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Manage zoneminder lib directories.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`zoneminder_manage_lib_dirs',`
+	gen_require(`
+		type zoneminder_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	manage_dirs_pattern($1, zoneminder_var_lib_t, zoneminder_var_lib_t)
+')
+
+########################################
+## <summary>
+##  Manage zoneminder sock_files files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`zoneminder_manage_lib_sock_files',`
+    gen_require(`
+        type zoneminder_var_lib_t;
+    ')
+    files_search_var_lib($1)
+    manage_sock_files_pattern($1, zoneminder_var_lib_t, zoneminder_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Search zoneminder spool directories.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`zoneminder_search_spool',`
+	gen_require(`
+		type zoneminder_spool_t;
+	')
+
+	allow $1 zoneminder_spool_t:dir search_dir_perms;
+	files_search_spool($1)
+')
+
+########################################
+## <summary>
+##	Read zoneminder spool files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`zoneminder_read_spool_files',`
+	gen_require(`
+		type zoneminder_spool_t;
+	')
+
+	files_search_spool($1)
+	read_files_pattern($1, zoneminder_spool_t, zoneminder_spool_t)
+')
+
+########################################
+## <summary>
+##	Manage zoneminder spool files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`zoneminder_manage_spool_files',`
+	gen_require(`
+		type zoneminder_spool_t;
+	')
+
+	files_search_spool($1)
+	manage_files_pattern($1, zoneminder_spool_t, zoneminder_spool_t)
+')
+
+########################################
+## <summary>
+##	Manage zoneminder spool dirs.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`zoneminder_manage_spool_dirs',`
+	gen_require(`
+		type zoneminder_spool_t;
+	')
+
+	files_search_spool($1)
+	manage_dirs_pattern($1, zoneminder_spool_t, zoneminder_spool_t)
+')
+
+########################################
+## <summary>
+##	Connect to zoneminder over a unix stream socket.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`zoneminder_stream_connect',`
+	gen_require(`
+		type zoneminder_t, zoneminder_var_lib_t;
+	')
+
+	files_search_pids($1)
+	stream_connect_pattern($1, zoneminder_var_lib_t, zoneminder_var_lib_t, zoneminder_t)
+')
+
+######################################
+## <summary>
+##  Read/write zonerimender tmpfs files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`zoneminder_rw_tmpfs_files',`
+    gen_require(`
+        type zoneminder_tmpfs_t;
+    ')
+
+    fs_search_tmpfs($1)
+    rw_files_pattern($1, zoneminder_tmpfs_t, zoneminder_tmpfs_t)
+')
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an zoneminder environment
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+## <param name="role">
+##	<summary>
+##	Role allowed access.
+##	</summary>
+## </param>
+## <rolecap/>
+#
+interface(`zoneminder_admin',`
+	gen_require(`
+		type zoneminder_t;
+	type zoneminder_initrc_exec_t;
+	type zoneminder_log_t;
+	type zoneminder_var_lib_t;
+	type zoneminder_spool_t;
+	')
+
+	allow $1 zoneminder_t:process { ptrace signal_perms };
+	ps_process_pattern($1, zoneminder_t)
+
+	zoneminder_initrc_domtrans($1)
+	domain_system_change_exemption($1)
+	role_transition $2 zoneminder_initrc_exec_t system_r;
+	allow $2 system_r;
+
+	logging_search_logs($1)
+	admin_pattern($1, zoneminder_log_t)
+
+	files_search_var_lib($1)
+	admin_pattern($1, zoneminder_var_lib_t)
+
+	files_search_spool($1)
+	admin_pattern($1, zoneminder_spool_t)
+
+')
+
Index: serefpolicy-contrib-20140730/zoneminder.te
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/zoneminder.te
@@ -0,0 +1,187 @@
+policy_module(zoneminder, 1.0.0)
+
+########################################
+#
+# Declarations
+#
+
+## <desc>
+## <p>
+## Allow ZoneMinder to run su/sudo.
+## </p>
+## </desc>
+gen_tunable(zoneminder_run_sudo, false)
+
+
+## <desc>
+## <p>
+## Allow ZoneMinder to modify public files
+## used for public file transfer services.
+## </p>
+## </desc>
+gen_tunable(zoneminder_anon_write, false)
+
+gen_require(`
+    class passwd rootok;
+    class passwd passwd;
+    ')
+
+type zoneminder_t;
+type zoneminder_exec_t;
+init_daemon_domain(zoneminder_t, zoneminder_exec_t)
+
+type zoneminder_unit_file_t;
+systemd_unit_file(zoneminder_unit_file_t)
+
+type zoneminder_initrc_exec_t;
+init_script_file(zoneminder_initrc_exec_t)
+
+type zoneminder_log_t;
+logging_log_file(zoneminder_log_t)
+
+type zoneminder_tmpfs_t;
+files_tmpfs_file(zoneminder_tmpfs_t)
+
+type zoneminder_spool_t;
+files_type(zoneminder_spool_t)
+
+type zoneminder_var_lib_t;
+files_type(zoneminder_var_lib_t)
+
+type zoneminder_var_run_t;
+files_pid_file(zoneminder_var_run_t)
+
+########################################
+#
+# zoneminder local policy
+#
+allow zoneminder_t self:capability { chown dac_override };
+allow zoneminder_t self:process { signal_perms setpgid };
+allow zoneminder_t self:shm create_shm_perms;
+allow zoneminder_t self:fifo_file rw_fifo_file_perms;
+allow zoneminder_t self:unix_stream_socket { create_stream_socket_perms connectto };
+allow zoneminder_t self:netlink_selinux_socket create_socket_perms;
+
+manage_dirs_pattern(zoneminder_t, zoneminder_log_t, zoneminder_log_t)
+manage_files_pattern(zoneminder_t, zoneminder_log_t, zoneminder_log_t)
+logging_log_filetrans(zoneminder_t, zoneminder_log_t, { dir file })
+
+manage_dirs_pattern(zoneminder_t, zoneminder_tmpfs_t, zoneminder_tmpfs_t)
+manage_files_pattern(zoneminder_t, zoneminder_tmpfs_t, zoneminder_tmpfs_t)
+manage_lnk_files_pattern(zoneminder_t, zoneminder_tmpfs_t, zoneminder_tmpfs_t)
+fs_tmpfs_filetrans(zoneminder_t, zoneminder_tmpfs_t, { dir file lnk_file })
+
+manage_dirs_pattern(zoneminder_t, zoneminder_var_lib_t, zoneminder_var_lib_t)
+manage_files_pattern(zoneminder_t, zoneminder_var_lib_t, zoneminder_var_lib_t)
+manage_sock_files_pattern(zoneminder_t, zoneminder_var_lib_t, zoneminder_var_lib_t)
+manage_lnk_files_pattern(zoneminder_t, zoneminder_var_lib_t, zoneminder_var_lib_t)
+files_var_lib_filetrans(zoneminder_t, zoneminder_var_lib_t, { dir file lnk_file sock_file })
+
+manage_dirs_pattern(zoneminder_t, zoneminder_var_run_t, zoneminder_var_run_t)
+manage_files_pattern(zoneminder_t, zoneminder_var_run_t, zoneminder_var_run_t)
+files_pid_filetrans(zoneminder_t, zoneminder_var_run_t, { dir file })
+
+manage_dirs_pattern(zoneminder_t, zoneminder_spool_t, zoneminder_spool_t)
+manage_files_pattern(zoneminder_t, zoneminder_spool_t, zoneminder_spool_t)
+manage_lnk_files_pattern(zoneminder_t, zoneminder_spool_t, zoneminder_spool_t)
+files_spool_filetrans(zoneminder_t, zoneminder_spool_t, { dir file })
+
+kernel_read_system_state(zoneminder_t)
+
+domain_read_all_domains_state(zoneminder_t)
+
+corecmd_exec_bin(zoneminder_t)
+corecmd_exec_shell(zoneminder_t)
+
+corenet_tcp_bind_http_cache_port(zoneminder_t)
+corenet_tcp_bind_transproxy_port(zoneminder_t)
+corenet_tcp_connect_http_port(zoneminder_t)
+
+dev_read_sysfs(zoneminder_t)
+dev_read_rand(zoneminder_t)
+dev_read_urand(zoneminder_t)
+dev_read_video_dev(zoneminder_t)
+dev_write_video_dev(zoneminder_t)
+
+auth_use_nsswitch(zoneminder_t)
+#auth_read_shadow(zoneminder_t)     need to debug zmpkg.pl to see why is needed this rule.
+
+logging_send_syslog_msg(zoneminder_t)
+logging_send_audit_msgs(zoneminder_t)
+
+mta_send_mail(zoneminder_t)
+
+tunable_policy(`zoneminder_anon_write',`
+	miscfiles_manage_public_files(zoneminder_t)
+')
+
+tunable_policy(`zoneminder_run_sudo',`
+    allow zoneminder_t self:capability { setuid setgid sys_resource };
+    allow zoneminder_t self:process { setrlimit setsched };
+    allow zoneminder_t self:key write;
+    allow zoneminder_t self:passwd { passwd rootok };
+
+    auth_rw_lastlog(zoneminder_t)
+    auth_rw_faillog(zoneminder_t)
+    auth_exec_chkpwd(zoneminder_t)
+
+    selinux_compute_access_vector(zoneminder_t)
+
+    systemd_write_inherited_logind_sessions_pipes(zoneminder_t)
+    systemd_dbus_chat_logind(zoneminder_t)
+
+    xserver_exec_xauth(zoneminder_t)
+')
+
+optional_policy(`
+    tunable_policy(`zoneminder_run_sudo',`
+        dbus_system_bus_client(zoneminder_t)
+    ')
+')
+
+optional_policy(`
+    tunable_policy(`zoneminder_run_sudo',`
+        sudo_exec(zoneminder_t)
+        su_exec(zoneminder_t)
+    ')
+')
+optional_policy(`
+	mysql_stream_connect(zoneminder_t)
+')
+
+optional_policy(`
+    fprintd_dbus_chat(zoneminder_t)
+')
+
+optional_policy(`
+    motion_manage_all_files(zoneminder_t)
+')
+
+########################################
+#
+# zoneminder cgi local policy
+#
+
+optional_policy(`
+	apache_content_template(zoneminder)
+	apache_content_alias_template(zoneminder, zoneminder)
+
+	# need more testing
+	#allow zoneminder_script_t self:shm create_shm_perms;
+
+	manage_sock_files_pattern(zoneminder_script_t, zoneminder_var_lib_t, zoneminder_var_lib_t)
+
+    rw_files_pattern(zoneminder_script_t, zoneminder_tmpfs_t, zoneminder_tmpfs_t)
+
+	zoneminder_stream_connect(zoneminder_script_t)
+
+    can_exec(zoneminder_t, zoneminder_script_exec_t)
+	
+	files_search_var_lib(zoneminder_script_t)
+
+	logging_send_syslog_msg(zoneminder_script_t)
+
+	optional_policy(`
+	    	mysql_stream_connect(zoneminder_script_t)
+	')
+')
Index: serefpolicy-contrib-20140730/zosremote.if
===================================================================
--- serefpolicy-contrib-20140730.orig/zosremote.if
+++ serefpolicy-contrib-20140730/zosremote.if
@@ -35,6 +35,7 @@ interface(`zosremote_domtrans',`
 ##	Role allowed access.
 ##	</summary>
 ## </param>
+## <rolecap/>
 #
 interface(`zosremote_run',`
 	gen_require(`
Index: serefpolicy-contrib-20140730/zosremote.te
===================================================================
--- serefpolicy-contrib-20140730.orig/zosremote.te
+++ serefpolicy-contrib-20140730/zosremote.te
@@ -24,6 +24,4 @@ allow zos_remote_t self:unix_stream_sock
 
 auth_use_nsswitch(zos_remote_t)
 
-miscfiles_read_localization(zos_remote_t)
-
 logging_send_syslog_msg(zos_remote_t)
